.model small,c
.386
.stack

include support.asm

; Host I/O ports for CRT Controller Address and Data Registers:
;
CRTCAddressRegister     equ 3d4h
CRTCDataRegister        equ 3d5h

; Index value for CRTC Start Address High Register:
;
StartAddressHighIndex   equ 0ch

; Index value for CRTC Start Address Low Register:
;
StartAddressLowIndex    equ 0dh

inp MACRO port
  ; Destroys ax and dx.
  mov   dx, port
  in    al, dx
  EXITM <al>
ENDM

outp MACRO port, val
  ; Destroys ax and dx.
  mov   dx, port
  mov   al, val
  out   dx, al
ENDM

.data
.code
.startup

    ; Set mode 10h, 640x350, 16-color, 2 display pages.
    ;
    mov   ax, 10h
    int   10h
    
    print "Display Page 0",NL

    outp CRTCAddressRegister,StartAddressHighIndex
    mov   bh, inp(CRTCDataRegister)

    outp CRTCAddressRegister,StartAddressLowIndex
    mov   bl, inp(CRTCDataRegister)
    
    print "CRTC Start Address = ",hexword$(bx),NL

    print NL,"Press any normal key to continue...",NL
    call waitkey

    ; Use the BIOS to switch the active page to page 1.
    ;
    mov   ax, 0501h
    int   10h

    print "Display Page 1",NL
    
    outp CRTCAddressRegister,StartAddressHighIndex
    mov   bh, inp(CRTCDataRegister)

    outp CRTCAddressRegister,StartAddressLowIndex
    mov   bl, inp(CRTCDataRegister)

    print "CRTC Start Address = ",hexword$(bx),NL   

    print NL,"Press any normal key to exit...",NL
    call waitkey
.exit
end
